#define BLYNK_TEMPLATE_ID "TMPL8bsYbN2n"
#define BLYNK_DEVICE_NAME "Display Sepeda Listrik"
#define BLYNK_AUTH_TOKEN "0i1wHPGOIdqvrXJdj4Ll1eD-01jOuXwK"

/* Comment this out to disable prints and save space */
#define BLYNK_PRINT Serial
#include <ESP8266WiFi.h>
#include <BlynkSimpleEsp8266.h>
#include <Preferences.h>
Preferences pref;
//Nama Wifi
char ssid[] = "JOE aneuk langsa";
char pass[] = "09877890";
//char ssid[] = "Clorovitt";
//char pass[] = "12345679";
//char ssid[] = "Galaxy A13";
//char pass[] = "wifiwifi";

#define speeds A0//pin connected to read baterai
#define baterai D7 // Define for IR Sensor
#define sensor D0 // Define for IR Sensor
#define merah D1 // mode speed 
#define biru D2 // mode speed
#define buzzer D5 // buzzer
#define crush D6 //tombol crush control

//storage variable
float Val= 0;
float km = 0; //kecepata km/h
float km1 = 0; //kecepata km/h
float km2 = 0; //kecepata km/h
float km3 = 0; //kecepata km/h
int d = 40; // diameter roda (cm)
float slider = 0;
float b = 7.89; 
float m1 = 0.516;
float m2 = 0.647;
float m3 = 0.777;
float nol = 178;
//
int buttonPushCounter = 0; // Kondisi tombol terkini
int buttonState = 0; // Kondisi tombol sebelumnya
int lastButtonState = 0;
unsigned long waktu;

int persen =0; //persen baterai


BLYNK_CONNECTED(){
  Blynk.syncVirtual(V6);
}
BLYNK_WRITE(V6){
  //Val = analogRead(speeds);//get val of A0 untuk kecepatan
  slider = param.asFloat();
  pref.putBool("slider", slider);
  Serial.println(slider);
}

void getbuzzerstate(){ //limit speed for buzzer state
    slider = pref.getBool("slider", 0);
    Blynk.virtualWrite(V6, slider);
    delay (200);
   // if (slider >= ((Val/10.24)*0.507)){ 
}
void setup() {
  pref.begin("buzzer_state", false);
  Serial.begin(115200);
  Serial.println("start");
  pinMode(merah, INPUT);
  pinMode(biru, INPUT);  
  pinMode(crush, INPUT);
  pinMode(buzzer, OUTPUT);
 // pinMode(baterai, INPUT);// Define Sensor pin as input
  pinMode(sensor, INPUT_PULLUP);// Define Sensor pin as input
    
  Blynk.begin(BLYNK_AUTH_TOKEN, ssid, pass);
  Serial.println();
  Serial.print("Connected");
  Serial.println();
  digitalWrite (merah, LOW);
  digitalWrite (biru, LOW); 
  digitalWrite (crush, LOW);
  digitalWrite (buzzer, LOW);
 // digitalWrite (baterai, HIGH);
  Blynk.virtualWrite(V5, LOW); 
  getbuzzerstate();
}

void loop() {
  Blynk.run();
  digitalWrite (buzzer, LOW);
  
  //BATERAI
  if (digitalRead (baterai) ==HIGH){
    Blynk.virtualWrite(V1, "100"); 
  }else {
    Blynk.virtualWrite(V1, "0"); 
  }
  
  //CRUSH CONTROL V1
  CRUSH_CONTROL();
      
  // MODE SPEED
  mode_speed(); //memanggil void mode_speed
   
  // LIMIT SPEED
  if ( (km) > slider){
  digitalWrite(buzzer,HIGH);
  Serial.println("buzzer on");
  Blynk.virtualWrite(V8, HIGH);
  }else{
  digitalWrite(buzzer,LOW);
  Serial.print("buzzer off");
  Blynk.virtualWrite(V8, LOW);
  }
  Serial.println();
  delay(1000);
}


void mode_speed(){
    Val = analogRead(speeds);//get val of A0 untuk kecepatan
  
  // NILAI speed1
  if (digitalRead (biru) ==LOW){
    Blynk.virtualWrite(V2, HIGH); 
    Blynk.virtualWrite(V3, LOW);
    Blynk.virtualWrite(V4, LOW);
  Serial.print("speed :");
  km1 = ((Val-nol)/b)*m1;
  Serial.println(km1);
  km = km1;
  Blynk.virtualWrite(V0, (km1));
  }
  // NILAI speed3
  if (digitalRead (merah) ==LOW){
    Blynk.virtualWrite(V2, LOW); 
    Blynk.virtualWrite(V3, LOW);
    Blynk.virtualWrite(V4, HIGH);
  Serial.print("speed :");
  km3 =((Val-nol)/b)*m3;
  Serial.println(km3);
  km=km3;
  Blynk.virtualWrite(V0, (km3));

  }
  // NILAI speed2
  if (digitalRead (merah) == digitalRead(biru) == HIGH){
    Blynk.virtualWrite(V2, LOW); 
    Blynk.virtualWrite(V3, HIGH);
    Blynk.virtualWrite(V4, LOW);
  Serial.print("speed :");
  km2 = ((Val-nol)/b)*m2;
  Serial.println(km2);
  km = km2;
  Blynk.virtualWrite(V0, (km2));
  }
}

void CRUSH_CONTROL(){
  //KM_H();
  // CRUSH CONTROL
  buttonState = digitalRead(crush); // Membandingkan kondisi tombol (buttonState) dengan sebelumnya (lastButtonState):
  if (buttonState != lastButtonState) {
    // Jika kondisi berubah, tingkatkan counter (penghitung):
    if (buttonState == LOW) {
      // Jika kondisi adalah HIGH makan tombol akan beralih dari off ke on:
      buttonPushCounter++;
      Serial.println("on");
      
      Serial.print("banyaknya tombol telah ditekan: ");
      Serial.println(buttonPushCounter);
      
    } else {
      // Jika kondisi adalah LOW makan tombol akan beralih dari on ke off:
      Serial.println("off");
      
    }
    // Penundaan untuk kestabilan sistem:
    delay(50);
  }
  // Menyimpan kondisi tombol sekarang sebagai kondisi sebelumnya
  // untuk looping selanjutnya:
  lastButtonState = buttonState;
    // Menghidupkan led apabila banyaknya tombol ditekan merupakan kelipatan 2
  // dengan menggunakan operator modulo/modulus. Modulo akan memberikan sisa
  // pembagian antara dua buah nilai:
  if (buttonPushCounter % 2 == 1) {
    //digitalWrite(ledcrush, HIGH);
    Blynk.virtualWrite(V5, HIGH); 
 
  } else {
    Blynk.virtualWrite(V5, LOW);
     
  }
}
